summaryrefslogtreecommitdiffstats
path: root/network/leafnode
diff options
context:
space:
mode:
Diffstat (limited to 'network/leafnode')
-rw-r--r--network/leafnode/README21
-rw-r--r--network/leafnode/doinst.sh8
-rw-r--r--network/leafnode/leafnode.SlackBuild110
-rw-r--r--network/leafnode/leafnode.info10
-rw-r--r--network/leafnode/sizeof_fix.diff12
-rw-r--r--network/leafnode/slack-desc19
6 files changed, 180 insertions, 0 deletions
diff --git a/network/leafnode/README b/network/leafnode/README
new file mode 100644
index 0000000000..08f7ca92b8
--- /dev/null
+++ b/network/leafnode/README
@@ -0,0 +1,21 @@
+Leafnode 2 is an NNTP proxy server intended for small sites, where
+there are few users and little disk space, but where a large number of
+groups is desired. It can also be used to give a regular newsreader
+off-line functionality.
+
+There is some work to do to install this program effectively, all
+of which is clearly set out in the README file contained in the
+documents. It is strongly advised that you read this file thoroughly
+before installing Leafnode 2. In summary you will need to:
+
+1. Ensure $NNTPSERVER or /etc/nntpserver points to 'localhost'.
+2. Set /etc/inetd.conf so leafnode is executed for incoming NNTP connections.
+3. Set /etc/hosts.deny and /etc/hosts.allow to protect the server.
+4. Create /etc/leafnode/config and adjust settings as required.
+5. Set cronjobs for fetchnews and texpire.
+6. Fetch the newsgroup list from the upstream server.
+7. Set your newsreader to use 'localhost'.
+
+Future versions of Leafnode 2 will have access to the lua programming /
+scripting language so we will be sitting tight with this particular version
+of Leafnode 2 until the lua-enabled version has matured a little.
diff --git a/network/leafnode/doinst.sh b/network/leafnode/doinst.sh
new file mode 100644
index 0000000000..f9a8bdcaa4
--- /dev/null
+++ b/network/leafnode/doinst.sh
@@ -0,0 +1,8 @@
+if [ ! -e etc/leafnode/local.groups ]; then
+ touch etc/leafnode/local.groups
+fi
+
+if [ ! -e etc/leafnode/moderators ]; then
+ touch etc/leafnode/moderators
+fi
+
diff --git a/network/leafnode/leafnode.SlackBuild b/network/leafnode/leafnode.SlackBuild
new file mode 100644
index 0000000000..c3a49a3ce8
--- /dev/null
+++ b/network/leafnode/leafnode.SlackBuild
@@ -0,0 +1,110 @@
+#!/bin/sh
+
+# Slackware build script for Leafnode 2
+
+# Copyright 2008-2009 Andrew Strong (http://www.andrews-corner.org)
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=leafnode
+VERSION=2.0.0.alpha20081229a
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+patch -p1 < $CWD/sizeof_fix.diff
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc/leafnode \
+ --mandir=/usr/man \
+ --localstatedir=/var \
+ --enable-runas-user=news \
+ --enable-spooldir=/var/spool/news \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/tools
+cp -a AUTHORS COPYING* CREDITS ChangeLog CHANGES-FROM-LEAFNODE-1 DEBUGGING \
+ FAQ.* INSTALL NEWS README* $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# The following files are marked in the documentation as 'not usually installed'
+# but I file them here (not installed) for the sake of completion :-)
+cp -a tools/* $PKG/usr/doc/$PRGNAM-$VERSION/tools
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/leafnode/leafnode.info b/network/leafnode/leafnode.info
new file mode 100644
index 0000000000..4790b46cc1
--- /dev/null
+++ b/network/leafnode/leafnode.info
@@ -0,0 +1,10 @@
+PRGNAM="leafnode"
+VERSION="2.0.0.alpha20081229a"
+HOMEPAGE="http://www-dt.e-technik.uni-dortmund.de/~ma/leafnode/beta/"
+DOWNLOAD="http://home.pages.de/~mandree/leafnode/beta/leafnode-2.0.0.alpha20081229a.tar.bz2"
+MD5SUM="63972974353e4da064cf2646b93cc586"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+MAINTAINER="Andrew Strong"
+EMAIL="andrew.david.45@gmail.com"
+APPROVED="rworkman"
diff --git a/network/leafnode/sizeof_fix.diff b/network/leafnode/sizeof_fix.diff
new file mode 100644
index 0000000000..a5e519dfb0
--- /dev/null
+++ b/network/leafnode/sizeof_fix.diff
@@ -0,0 +1,12 @@
+--- a/system.h 2008-12-29 22:24:30.000000000 +1100
++++ b/system.h 2010-05-26 19:39:22.376358080 +1000
+@@ -20,9 +20,6 @@
+ #include <inttypes.h>
+ #elif HAVE_STDINT_H
+ #include <stdint.h>
+-#elif sizeof(unsigned long) == 4 && sizeof(unsigned char) == 1
+-typedef unsigned long uint32_t;
+-typedef unsigned char uint8_t;
+ #else
+ #error "I cannot figure how to define uint32_t and uint8_t."
+ #endif
diff --git a/network/leafnode/slack-desc b/network/leafnode/slack-desc
new file mode 100644
index 0000000000..dd794cb89c
--- /dev/null
+++ b/network/leafnode/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler-----------------------------------------------------|
+leafnode: Leafnode-2 (an NNTP proxy server)
+leafnode:
+leafnode: Leafnode-2 is an NNTP proxy server intended for small sites, where
+leafnode: there are few users and little disk space, but where a large number
+leafnode: of groups is desired. It can also be used to give a regular
+leafnode: newsreader off-line functionality. The leafnode program itself is
+leafnode: the server while the programs fetchnews and texpire transport the
+leafnode: the news and expire old articles respectively.
+leafnode:
+leafnode: Homepage: http://www-dt.e-technik.uni-dortmund.de/~ma/leafnode/beta/
+leafnode: